<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>
      <q-header elevated>
        <q-toolbar class="pl-toolbar">
          <q-btn flat round dense icon="arrow_back" @click="$router.back()" />
          <q-toolbar-title>
            {{ $t("upcoming_conference.page_title") }}
          </q-toolbar-title>
        </q-toolbar>
      </q-header>

      <q-page class="pl-fullpage">
        <div class="row q-mr-md">
          <h5 class="q-ma-md col">
            {{ conference.Name }}
            <q-popup-proxy v-model="editingName">
              <q-card>
                <q-form @submit="handleUpdateName">
                  <q-card-section class="q-pb-none">
                    <q-input :rules="[(val) => (val && val.length > 0) || $t('empty.name')]" v-model="editNameValue"
                      dense autofocus class="q-pb-sm" />
                  </q-card-section>
                  <q-card-actions class="q-pt-none" align="right">
                    <q-btn flat type="submit" color="primary" :label="$t('save')" />
                  </q-card-actions>
                </q-form>
              </q-card>
            </q-popup-proxy>
          </h5>
          <q-btn class="col-auto" round flat color="grey" icon="edit" @click="
            {
              editingName = true;
              editNameValue = conference.Name;
            }
          " />
        </div>
        <div class="q-mx-md">
          <div class="q-ma-none text-body1 text-grey">
            {{ $t("upcoming_conference.scheduled_for") }}
          </div>
          <div class="row items-center">
            <div class="col">
              {{ formattedScheduledStartTime }}
            </div>
            <q-btn round flat icon="edit" class="col-auto" color="grey" @click="editingDate = true" />
          </div>
          <div class="q-ma-none q-mt-sm text-body1 text-grey">
            {{ $t("upcoming_conference.privacy_title") }}
          </div>
          <div class="row items-center">
            <div class="col">
              {{ conferencePrivacyDescription }}
            </div>
            <q-popup-proxy v-model="editingPrivacy">
              <q-card>
                <q-form @submit="handleUpdatePrivacy">
                  <q-card-section class="q-pb-none">
                    <q-option-group :options="privacyOptions" type="radio" v-model="editingPrivacySelection" />
                  </q-card-section>
                  <q-card-actions align="right">
                    <q-btn flat type="submit" color="primary" :label="$t('save')" />
                  </q-card-actions>
                </q-form>
              </q-card>
            </q-popup-proxy>

            <q-btn class="col-auto" color="grey" @click="
              {
                editingPrivacy = true;
                editingPrivacySelection = conferencePrivacyRadioValue;
              }
            " round flat icon="edit" />
          </div>
          <div class="row items-center q-my-md q-mt-lg">
            <h6 class="q-ma-none col">
              {{ $t("upcoming_conference.participants") }}
            </h6>
            <q-btn @click="handleRequestAddParticipant" class="col-auto" color="primary" round icon="add" />
          </div>
          <ManageParticipantsList :participants="conference.Participants" :trunk="chosenTrunk"
            :requestToggleModerator="handleRequestToggleModerator" :requestDelete="handleRequestRemoveParticipant"
            :usersPhone="user.Phone || ''" />

          <div class="row items-center q-my-md q-mt-lg">
            <h6 class="q-ma-none col">
              {{ $t("upcoming_conference.agenda") }}
            </h6>
          </div>

          <AgendaEditList :participants="conference.Participants" :agenda="conference.Agenda"
            :usersPhone="user.Phone || ''" :saveChanges="handleSaveAgenda" />
        </div>
        <q-page-sticky v-if="allowStartConference" position="bottom-right" class="pl-fullpage">
          <q-btn @click="handleRequestStartConference" fab color="positive" class="q-ma-sm">
            <div class="q-px-sm">
              {{ $t("upcoming_conference.start_conference") }}
            </div>
            <q-icon name="play_arrow" />
          </q-btn>
        </q-page-sticky>
        <q-page-sticky position="bottom-left" class="pl-fullpage">
          <q-btn @click="requestCancelConference" fab color="red" class="q-ma-sm">
            <q-icon name="delete" />
          </q-btn>
        </q-page-sticky>
        <q-dialog v-model="showAddParticipantDialog">
          <AddParticipantForm :user="user" :conference="conference" :addParticipant="handleAddParticipant" />
        </q-dialog>

        <q-dialog v-model="editingDate">
          <q-card style="width:100%">

            <q-card-section class="q-pt-none">
              <Scheduler :existingEvents="{ ...liveConferences, ...upcomingConferences }"
                :updateEvent="updatedFromScheduler" :maxCapacity="maxCapacity" :trunks="trunks" :chosenTrunk="chosenTrunk"
                :existingStartTime="new Date(conference.ScheduledStart)" :existingCapacity="conference.MaxCapacity"
                :existingLengthMins="conference.LengthMins" :editingEventId="this.$route.params.id" />
            </q-card-section>

            <q-card-actions align="right">
              <q-btn flat :label="$t('cancel')" color="primary" v-close-popup />
              <q-btn flat :label="$t('ok')" @click="saveScheduleEdit" color="primary" v-close-popup />
            </q-card-actions>
          </q-card>
        </q-dialog>

      </q-page>
    </q-page-container>
  </q-layout>
</template>
<script>
import ManageParticipantsList from "../components/ManageParticipantsList.vue";
import AddParticipantForm from "../components/AddParticipantForm.vue";
import AgendaEditList from "../components/AgendaEditList.vue";
import Scheduler from "../components/Scheduler.vue";
import { auth, db, functions } from "../firebase";
import moment from 'moment'

export default {
  data()
  {
    return {
      conference: { loading: true },
      user: { loading: true },
      liveConferences: { loading: true },
      upcomingConferences: { loading: true },
      showAddParticipantDialog: false,
      proxyDate: undefined,
      proxyTime: undefined,
      editingDate: false,
      editingName: false,
      editNameValue: "",
      editingPrivacy: false,
      maxCapacity: 50, // TODO
      editedStartTime: null,
      editedLengthMins: null,
      editedCapacity: null,
      editedTrunk: null,
      trunks: {},
      privacyOptions: [
        {
          label: this.$t("privacy.open"),
          value: "open",
        },
        {
          label: this.$t("privacy.private"),
          value: "private",
        },
        {
          label: this.$t("privacy.closed"),
          value: "closed",
        },
      ],
      editingPrivacySelection: "",
    };
  },
  computed: {
    chosenTrunk()
    {
      return this.trunks[this.conference.DropCallJoinNumber];
    },
    formattedScheduledStartTime()
    {
      return `${moment(this.conference.ScheduledStart).format(
        this.$t("upcoming_conference.format_date_time")
      )} - ${moment(this.conference.ScheduledEnd).format('HH:mm')} | ${this.$t("upcoming_conference.capacity", [this.conference.MaxCapacity])}`
    },
    allowStartConference()
    {
      return moment(this.conference.ScheduledStart) < moment();
    },
    conferencePrivacyDescription()
    {
      return this.$t(`privacy.${this.conferencePrivacyRadioValue}`);
    },
    conferencePrivacyRadioValue()
    {
      const privacy = this.conference.Privacy || {};
      if (privacy.IsPublic) return "open";
      if (privacy.AcceptContacts) return "private";
      return "closed";
    },
  },
  created()
  {
    this.$rtdbBind(
      "conference",
      db.ref(`Conferences/Upcoming/${this.$route.params.id}`)
    )

    this.$rtdbBind("liveConferences", db.ref("Conferences/Live"));
    this.$rtdbBind("upcomingConferences", db.ref("Conferences/Upcoming"));

    this.$rtdbBind("trunks", db.ref("System/Trunks"));

    this.$rtdbBind("user", db.ref(`Users/${auth.currentUser.uid}`))
  },
  watch: {
    conference(newConf)
    {
      if (!newConf.Name)
      {
        console.log('Conference has been moved or deleted, return to homepage');
        this.$router.replace({
          name: 'Dashboard'
        });
      }
    },
  },
  methods: {
    async handleSaveAgenda(newData)
    {
      this.$q.loading.show();
      const updateAgenda = functions.httpsCallable("updateConferenceAgenda");
      await updateAgenda({
        ConferenceId: this.$route.params.id,
        Agenda: newData
      }).catch((error) =>
      {
        this.$q.notify({
          type: "negative",
          message: error,
        });
      });
      this.$q.loading.hide();
    },
    updatedFromScheduler(startTime, length, capacity, trunk)
    {
      this.editedStartTime = startTime;
      this.editedLengthMins = length;
      this.editedCapacity = capacity;
      this.editedTrunk = trunk;
      console.log('new trunk', trunk)
    },
    async saveScheduleEdit()
    {
      if (!this.editedStartTime || !this.editedLengthMins || !this.editedCapacity || !this.editedTrunk) return;

      console.log(this.editedTrunk)

      const updateConferenceFB = functions.httpsCallable("updateConference");
      this.$q.loading.show();
      await updateConferenceFB({
        ConferenceId: this.$route.params.id,
        ScheduledStart: moment(this.editedStartTime).valueOf(),
        LengthMins: this.editedLengthMins,
        MaxCapacity: this.editedCapacity,
        DropCallJoinNumber: this.editedTrunk.caller_number
      });
      this.$q.loading.hide();
    },
    async handleRequestToggleModerator(phoneNumber)
    {
      this.$q.loading.show();
      const updateParticipant = functions.httpsCallable("addParticipant");
      await updateParticipant({
        ConferenceId: this.$route.params.id,
        PhoneNumber: phoneNumber,
        Name: this.conference.Participants[phoneNumber].Name,
        Moderator: !this.conference.Participants[phoneNumber].Moderator,
      }).catch((error) =>
      {
        this.$q.notify({
          type: "negative",
          message: error,
        });
      });
      this.$q.loading.hide();
    },
    handleRequestRemoveParticipant(phoneNumber)
    {
      this.$q
        .dialog({
          title: this.$t("confirm"),
          message: this.$t("upcoming_conference.confirm_remove_participant"),
          ok: { label: this.$t("confirm"), flat: true, color: "negative" },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
        .onOk(async () =>
        {
          this.$q.loading.show();
          const removeParticipantFb =
            functions.httpsCallable("removeParticipant");
          await removeParticipantFb({
            ConferenceId: this.$route.params.id,
            PhoneNumber: phoneNumber,
          });
          this.$q.loading.hide();
        });
    },
    handleRequestAddParticipant()
    {
      this.showAddParticipantDialog = true;
    },
    async handleAddParticipant(phoneNumber, participant)
    {
      this.$q.loading.show();
      const addParticipant = functions.httpsCallable("addParticipant");
      await addParticipant({
        ConferenceId: this.$route.params.id,
        PhoneNumber: phoneNumber,
        Name: participant.Name,
        Moderator: participant.Moderator,
      }).catch((error) =>
      {
        this.$q.notify({
          type: "negative",
          message: error,
        });
      });
      this.$q.loading.hide();
      this.showAddParticipantDialog = false;
    },
    async handleRequestStartConference()
    {
      this.$router.push(`/begin/${this.$route.params.id}`);
    },
    requestCancelConference()
    {
      this.$q
        .dialog({
          title: this.$t("confirm"),
          message: this.$t("upcoming_conference.confirm_cancel_conference"),
          ok: { label: this.$t("confirm"), flat: true, color: "negative" },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
        .onOk(async () =>
        {
          this.$q.loading.show();
          const cancelUpcomingConference = functions.httpsCallable("cancelUpcomingConference");
          await cancelUpcomingConference({
            ConferenceId: this.$route.params.id,
          }).catch((error) =>
          {
            this.$q.notify({
              type: "negative",
              message: error,
            });
          });
          this.$router.replace({
            name: 'Dashboard'
          });
          this.$q.loading.hide();
        });
    },
    updateProxy()
    {
      const scheduledStartDateTime = moment(
        this.conference.ScheduledStart
      );
      this.proxyDate = scheduledStartDateTime.format("yyyy/MM/dd");
      this.proxyTime = scheduledStartDateTime.format("hh:mm a");
      this.editingDate = true;
    },
    handleDoneEditingDate()
    {
      this.editingDate = false;
      this.editingTime = true;
    },
    async handleUpdateName()
    {
      const updateConferenceFB = functions.httpsCallable("updateConference");
      this.$q.loading.show();
      await updateConferenceFB({
        ConferenceId: this.$route.params.id,
        Name: this.editNameValue,
      });
      this.$q.loading.hide();
      this.editingName = false;
    },
    async handleUpdatePrivacy()
    {
      const updateConferenceFB = functions.httpsCallable("updateConference");
      const newPrivacy = {
        IsPublic: this.editingPrivacySelection === "open",
        AcceptContacts:
          this.editingPrivacySelection === "open" ||
          this.editingPrivacySelection === "private",
      };
      this.$q.loading.show();
      await updateConferenceFB({
        ConferenceId: this.$route.params.id,
        Privacy: newPrivacy,
      });
      this.$q.loading.hide();
      this.editingPrivacy = false;
    },
  },
  components: {
    AddParticipantForm,
    ManageParticipantsList,
    AgendaEditList,
    Scheduler
  },
};
</script>
